import tecplot as tp
import numpy as np
import os
from tecplot.exception import *
from tecplot.constant import *

# Uncomment the following line to connect to a running instance of Tecplot 360:
tp.session.connect()

tp.macro.execute_command("$!Page Name = 'Untitled'")
tp.macro.execute_command('$!PageControl Create')
tp.new_layout()
tp.data.load_tecplot(os.path.join(os.getcwd(),'Axial.plt'))
#tp.macro.execute_command("""$!ReadDataSet  'Axial.plt'
#  ReadDataOption = New
#  ResetStyle = Yes
# VarLoadMode = ByName
# AssignStrandIDs = Yes
# VarNameList = '\"X\" \"Y\" \"Z\" \"Conductivity\" \"Specific Heat\" \"Density\" \"Mach Number\" \"Pressure\" \"Total Pressure\" \"Temperature\" \"Total Temperature\" \"U\" \"V\" \"W\" \"R\"'""")
tp.active_frame().plot().slice(0).orientation=SliceSurface.ZPlanes
tp.active_frame().plot(PlotType.Cartesian3D).show_slices=True
tp.active_frame().plot().slice(0).origin=(tp.active_frame().plot().slice(0).origin[0],
    tp.active_frame().plot().slice(0).origin[1],
    0.133281)
tp.active_frame().plot().contour(0).variable_index=3
tp.macro.execute_command('''$!Pick SetMouseMode
  MouseMode = Select''')
tp.macro.execute_command('''$!Pick AddAtPosition
  X = 4.95123258307
  Y = 2.52224008574
  CollectingObjectsMode = AlwaysAdd
  ConsiderStyle = Yes''')
tp.macro.execute_command('$!GlobalRGB RedChannelVar = 15')
tp.macro.execute_command('$!GlobalRGB GreenChannelVar = 4')
tp.macro.execute_command('$!GlobalRGB BlueChannelVar = 4')
tp.active_frame().plot().contour(1).variable_index=4
tp.active_frame().plot().contour(2).variable_index=5
tp.active_frame().plot().contour(3).variable_index=6
tp.active_frame().plot().contour(4).variable_index=7
tp.active_frame().plot().contour(5).variable_index=8
tp.active_frame().plot().contour(6).variable_index=9
tp.active_frame().plot().contour(7).variable_index=10
tp.active_frame().plot().fieldmap(4).mesh.show=False
tp.active_frame().plot().fieldmap(4).contour.show=False
tp.active_frame().plot().fieldmap(4).vector.show=False
tp.active_frame().plot().fieldmap(4).scatter.show=False
tp.active_frame().plot().fieldmap(4).shade.show=False
tp.active_frame().plot().fieldmap(4).edge.show=False
tp.macro.execute_command('''$!Pick AddAtPosition
  X = 5.1741693462
  Y = 1.52759914255
  CollectingObjectsMode = AlwaysAdd
  ConsiderStyle = Yes''')
tp.active_frame().plot().fieldmap(3).mesh.show=False
tp.active_frame().plot().fieldmap(3).contour.show=False
tp.active_frame().plot().fieldmap(3).vector.show=False
tp.active_frame().plot().fieldmap(3).scatter.show=False
tp.active_frame().plot().fieldmap(3).shade.show=False
tp.active_frame().plot().fieldmap(3).edge.show=False
tp.macro.execute_command('$!RedrawAll')
tp.macro.execute_command('''$!ExtractSlices 
  Group = 1
  ExtractMode = SingleZone''')
tp.active_frame().plot().contour(0).variable_index=14
tp.active_frame().plot().contour(0).levels.reset_levels([0.38417, 0.389058, 0.393946, 0.398834, 0.403723, 0.408611, 0.413499, 0.418387, 0.423276, 0.428164, 0.433052, 0.437941, 0.442829, 0.447717, 0.452605])
tp.active_frame().plot(PlotType.Cartesian3D).show_slices=False
tp.macro.execute_command('$!RedrawAll')
tp.active_frame().plot().fieldmap(15).contour.contour_type=ContourType.Lines
tp.active_frame().plot().show_contour=True
tp.macro.execute_command('$!RedrawAll')

dataset = tp.active_frame().dataset
num_init_zone = dataset.num_zones

tp.macro.execute_command('''$!CreateContourLineZones 
  ContLineCreateMode = OneZonePerContourLevel''')
num_final_zone = dataset.num_zones

final_var_values = []
final_rad_values = []

for i in range(num_init_zone, num_final_zone):
    curzone = dataset.zone(i)
    
    values = curzone.values('Total Pressure').as_numpy_array()
    avg = np.average(values)
    
    rad = curzone.values('R')[0]
    final_var_values.append(avg)
    final_rad_values.append(rad)
    
    
tp.macro.execute_command('''$!CreateRectangularZone 
  IMax = 15
  JMax = 1
  KMax = 1
  X1 = 0.370904147625
  Y1 = -0.0250263158232
  Z1 = -0.0502139441669
  X2 = 0.457189023495
  Y2 = 0.102241754532
  Z2 = 0.157443419099''')

result_zone = dataset.zone(-1)
result_zone.values('Total Pressure')[:] = final_var_values
result_zone.values('R')[:] = final_rad_values


tp.macro.execute_command('''$!CreateNewFrame 
  XYPos
    {
    X = 5.4143
    Y = 3.7141
    }
  Width = 6.2937
  Height = 4.3816''')
tp.macro.execute_command('''$!FrameControl ActivateAtPosition
  X = 4.04233654877
  Y = 2.57368703108''')
tp.macro.execute_command('''$!Pick SetMouseMode
  MouseMode = Select''')
tp.macro.execute_command('''$!Pick SetMouseMode
  MouseMode = Select''')
tp.macro.execute_command('''$!FrameControl ActivateAtPosition
  X = 6.41747052519
  Y = 5.24892818864''')
tp.macro.execute_command('''$!Pick AddAtPosition
  X = 6.41747052519
  Y = 5.24892818864
  ConsiderStyle = Yes''')
tp.active_frame().plot_type=PlotType.XYLine
tp.active_frame().plot().delete_linemaps()
tp.active_frame().plot().add_linemap()
tp.active_frame().plot().linemap(0).name='Map 0'
tp.active_frame().plot().linemap(0).x_variable_index=8
tp.active_frame().plot().linemap(0).y_variable_index=14
tp.active_frame().plot().linemap(0).zone_index=31
#  $!ActiveLineMaps  +=  [1]
tp.active_frame().plot().linemap(0).show=True
tp.active_frame().plot().view.fit()
tp.active_frame().plot(PlotType.XYLine).show_symbols=True
tp.macro.execute_command('$!RedrawAll')
# End Macro.

